#include"DHT11_Lib_12F1840.h"
#include"My_UART1_Lib.h"
#define CLS 12
#define LF 10
#define TAB 9
#define Blancs "  "  // 2  spaces
#define Separator 0x20   // 1 space
#define MAX_LEN1 128
#define MAX_LEN2 24
#define MAX_LEN3 80
unsigned char Buffer[MAX_LEN1];
unsigned short read_vec[3];
unsigned char CRam1[MAX_LEN2];

void Float2Ascii (float x, unsigned char *str,char precision)
{
 /* converts a floating point number to an ascii string */
 /* x is stored into str, which should be at least 30 chars long */
 int ie, i, k, ndig;
 double y;
 ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
 ie = 0;
 /* if x negative, write minus and reverse */
 if ( x < 0)
 {
   *str++ = '-';
   x = -x;
 }
 /* put x in range 1 <= x < 10 */
 if (x > 0.0) while (x < 1.0)
 {
   x *= 10.0;                // a la place de =*
   ie--;
 }
 while (x >= 10.0)
 {
   x = x/10.0;
   ie++;
 }
 // in f format, number of digits is related to size
 ndig += ie;                                // a la place de =+
 //round. x is between 1 and 10 and ndig will be printed to
 // right of decimal point so rounding is ...
 for (y = i = 1; i < ndig; i++)
 y = y/10.;
 x += y/2.;
 if (x >= 10.0) {x = 1.0; ie++;}
 if (ie<0)
 {
   *str++ = '0'; *str++ = '.';
   if (ndig < 0) ie = ie-ndig;
   for (i = -1; i > ie; i--)  *str++ = '0';
 }
 for (i=0; i < ndig; i++)
 {
   k = x;
   *str++ = k + '0';
   if (i ==  ie ) *str++ = '.';
   x -= (y=k);
   x *= 10.0;
  }
 *str = '\0';
}


void fill_buffer(float t , unsigned short th)
{
 unsigned short i,vect_t[4],vect_th[4];
 
 Float2Ascii (t,vect_t,1); ByteToStr(th,vect_th);
 for(i=0;i<3;i++) {UART1_Write('.');delay_ms(200);} // erase Buffer vector.
 
 for(i=0 ; i<MAX_LEN1 ; i++) Buffer[i]=0 ;
 
 Buffer[0]='.';Buffer[1]='T';Buffer[2]='E';Buffer[3]='M';
 Buffer[4]='P';Buffer[5]=':';Buffer[6]=vect_t[0];Buffer[7]=vect_t[1];
 Buffer[8]=vect_t[2];Buffer[9]=vect_t[3];Buffer[10]='C';Buffer[11]=' ';
 Buffer[12]=' ';Buffer[13]='H';Buffer[14]='U';
 Buffer[15]='M';Buffer[16]='I';Buffer[17]='D';Buffer[18]=':';
 Buffer[19]=vect_th[1];Buffer[20]=vect_th[2];Buffer[21]='%';
}

void main() {
  unsigned short sum;
  unsigned char *text,t;
  unsigned char mytext[4];
  float v_temp;
  // SET INTERNAL OSCILLATOR TO 32MHZ (INTERNAL CLOCK AY 8 + PLLEN=4X)
  OSCCON.SCS0 = 0;OSCCON.SCS1 =1;
  OSCCON.IRCF0=0; OSCCON.IRCF1=1; OSCCON.IRCF3=1; OSCCON.IRCF3=1;
  OSCCON.SPLLEN=1 ;
  PORTA=0;
  ANSELA = 0x00; // All pins digital
  ADCON0 = 0x00; // Disable ADC
  CM1CON0.C1ON = 0; // Disable Comparator

  // Initalize USART (9600,8,N,1)
  UART1_Init(9600);
  Delay_ms(500);
  UART1_Write(CLS);
  My_CRLF();

  My_UART1_Write_CText("Program acuire Humidity \r\n");
  My_UART1_Write_CText("and Temperature values \r\n");
  My_UART1_Write_CText("fron DHT11 sensor\r\n");
  My_CRLF();

 //TRISA = 0;        //Configure PORTB as output
 //PORTA = 0;        //Initial value of PORTB
 while(1){
          StartSignal();
          if(CheckResponse()){
               ReadData();

               if(sum = read_vec[0] + read_vec[1]){
                 v_temp = read_vec[1]-2;  // -2 is calibration number
                 v_temp = v_temp + (float)(read_vec[2]*0.010); //for temp dozen

                 fill_buffer(v_temp,read_vec[0]);
                 My_UART1_Write_CText(Buffer); My_CRLF();
                // the 3 lines below is for testing only temperature value:
                //Float2Ascii (v_temp,CRam1,1);
                //My_UART1_Write_CText(CRam1); My_UART1_Write_Text("\r\n");
                //My_UART1_Write_CText(t);//My_UART1_Write_CText("C");
                }                  // UART1_Write_Text
               else error();
             }
          else error();
          delay_ms(300);
          }  // END WHILE

} // End Main




// ================================================================
//          Vss RA0 RA1 RA2           RA0: TX
//            |  |  |  |              RA1: RX ; SCL
//           +----------+             RA2: SDA
//           o 12F1840  |             RA3:
//           +----------+             RA4:
//            |  |  |  |              RA5:
//          Vdd RA5 RA4 RA3
//
//  INTERNAL CLOCK AT 4MHZ + PLL AT 4X = 32 MHZ REAL INTERNAL CLOCK
//  DHT11 Temperature and Humidity sensor
// ================================================================
// ByteToStr(rh,mytext);Ltrim(mytext));